//+------------------------------------------------------------------+
//|                                               TicksCollector.mq5 |
//|                               Copyright 2020, Vladimir Mikhailov |
//|                                                mikh.vl@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, Vladimir Mikhailov"
#property link      "mikh.vl@gmail.com"
#property version   "1.00"
input int TotalTicks=1000000;
MqlTick tick[1], ticks[];
int counter=0;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   ArrayResize(ticks,TotalTicks);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   int h=FileOpen("ticks_data", FILE_WRITE|FILE_BIN);
   if(h!=INVALID_HANDLE)
      {
       ArrayResize(ticks,counter);
       FileWriteArray(h,ticks);
       FileClose(h);
      }
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   CopyTicks(_Symbol,tick,COPY_TICKS_ALL,0,1);
   
   ticks[counter].ask=tick[0].ask;
   ticks[counter].bid=tick[0].bid;
   ticks[counter].flags=tick[0].flags;
   ticks[counter].last=tick[0].last;
   ticks[counter].time=tick[0].time;
   ticks[counter].time_msc=tick[0].time_msc;
   ticks[counter].volume=tick[0].volume;
   ticks[counter].volume_real=tick[0].volume_real;
   
   counter++;
   
   if(counter>=TotalTicks)ExpertRemove();
  
  }
//+------------------------------------------------------------------+
